import { WithStyles } from '@mui/styles';
import * as React from 'react';
import { DistributiveOmit } from '@mui/types';
import { WTheme } from '../../others/w-theme-provider/w-theme';
import { BaseComponentProps } from '../../base/base-component-props';
import { WTextFieldProps } from '../w-text-field';
export interface WSelectOptionGroup {
    label: string;
    options: WSelectOption[];
}
export interface WSelectOption {
    icon?: string | React.ReactElement<any>;
    iconSource?: 'material-icons' | 'fontawesome';
    label?: string;
    value: any;
}
export type WSelectProps = BaseComponentProps & DistributiveOmit<WithStyles<typeof styles>, "classes"> & {
    isClearable?: boolean;
    isDisabled?: boolean;
    isLoading?: boolean;
    isMulti?: boolean;
    isSearchable?: boolean;
    error?: boolean;
    label?: string;
    helperText?: string;
    name?: string;
    onBlur?: (event: React.FocusEvent<HTMLElement>) => void;
    onChange?: (value: any, object?: any) => void;
    onFocus?: (event: React.FocusEvent<HTMLElement>) => void;
    onMenuOpen?: () => void;
    onMenuClose?: () => void;
    options?: (WSelectOption)[];
    value?: any;
    defaultValue?: any;
    theme?: any;
    style?: React.CSSProperties;
    components?: any;
    hideSelectedOptions?: boolean;
    size?: WTextFieldProps["size"];
};
declare const styles: (theme: WTheme) => import("@mui/styles").StyleRules<{}, "input" | "placeholder" | "noOptionsMessage" | "dropdownIndicator" | "singleValue" | "valueContainer" | "paper" | "chip" | "chipFocused">;
export declare const WSelect: any;
export {};
