"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WSelect = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const NoSsr_1 = __importDefault(require("@mui/material/NoSsr"));
const styles_1 = require("@mui/material/styles");
const createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
const withStyles_1 = __importDefault(require("@mui/styles/withStyles"));
const React = __importStar(require("react"));
const react_select_1 = __importDefault(require("react-select"));
const components_1 = __importDefault(require("./components"));
class WSelectInner extends React.Component {
    constructor(props) {
        super(props);
        this.getCleanValue = () => {
            const find = (value) => {
                var _a;
                return (_a = this.props.options) === null || _a === void 0 ? void 0 : _a.find(option => option.value == value);
            };
            if (this.props.isMulti && this.props.value) {
                const result = [];
                this.props.value.forEach(value => {
                    const option = find(value);
                    if (option) {
                        result.push(option);
                    }
                });
                return result;
            }
            else if (typeof this.props.value !== 'object') {
                return find(this.props.value);
            }
            else {
                return this.props.value;
            }
        };
        this.setFocus = (event, focused) => {
            this.setState({ focused: focused });
            if (focused && this.props.onFocus) {
                this.props.onFocus(event);
            }
            else if (!focused && this.props.onBlur) {
                this.props.onBlur(event);
            }
        };
        this.onChange = (value) => {
            if (this.props.onChange) {
                if (this.props.isMulti) {
                    this.props.onChange(value.map((item) => item.value), value);
                }
                else {
                    this.props.onChange(value ? value.value : null, value);
                }
            }
        };
        this.select = React.createRef();
        this.state = {
            focused: false,
        };
    }
    render() {
        // @ts-ignore
        const cleanValue = this.getCleanValue();
        let hasValue = (this.select.current && this.select.current.commonProps.getValue().length > 0);
        hasValue = hasValue || (this.props.isMulti ? cleanValue && cleanValue.length > 0 : cleanValue);
        return ((0, jsx_runtime_1.jsx)(NoSsr_1.default, { children: (0, jsx_runtime_1.jsx)(react_select_1.default, Object.assign({ ref: this.select }, this.props, { components: Object.assign(Object.assign({}, components_1.default), this.props.components), styles: customStyles, onFocus: (event) => this.setFocus(event, true), onBlur: (event) => this.setFocus(event, false), onChange: this.onChange, classNamePrefix: "w_select", placeholder: "", value: cleanValue, 
                //@ts-ignore
                textFieldProps: {
                    label: this.props.label,
                    InputLabelProps: {
                        shrink: this.state.focused || hasValue,
                    },
                    error: this.props.error,
                    helperText: this.props.helperText,
                    style: this.props.style,
                    size: this.props.size
                } })) }));
    }
}
const customStyles = {
    dropdownIndicator: (provided) => (Object.assign(Object.assign({}, provided), { padding: 6 })),
    clearIndicator: (provided) => (Object.assign(Object.assign({}, provided), { padding: 6 })),
    menuPortal: (provided) => (Object.assign(Object.assign({}, provided), { zIndex: 9999 })),
};
const styles = (theme) => (0, createStyles_1.default)({
    input: {
        display: 'flex !important',
        padding: '9.5px 14px !important',
        height: 'auto !important'
    },
    valueContainer: {
        display: 'flex',
        // flexWrap: 'wrap',
        flex: 1,
        alignItems: 'center',
        overflow: 'hidden',
    },
    chip: {
        margin: `${theme.spacing(0.25)} ${theme.spacing(0.25)}`,
        height: 28
    },
    chipFocused: {
        backgroundColor: (0, styles_1.emphasize)(theme.palette.mode === 'light' ? theme.palette.grey[300] : theme.palette.grey[700], 0.08),
    },
    noOptionsMessage: {
        padding: `${theme.spacing(1)} ${theme.spacing(2)}`,
    },
    singleValue: {
        fontSize: 16,
    },
    placeholder: {
        position: 'absolute',
        left: 2,
        fontSize: 16,
    },
    paper: {
        position: 'absolute',
        zIndex: theme.zIndex.modal + 1,
        marginTop: theme.spacing(1),
        left: 0,
        right: 0
    },
    dropdownIndicator: {
        padding: 40
    }
});
exports.WSelect = (0, withStyles_1.default)(styles, { withTheme: false })((props) => (0, jsx_runtime_1.jsx)(WSelectInner, Object.assign({}, props)));
