"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WCarousel = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = __importStar(require("react"));
// @ts-ignore
const react_swipeable_views_1 = __importDefault(require("react-swipeable-views"));
const withTheme_1 = __importDefault(require("@mui/styles/withTheme"));
const w_icon_1 = require("../../medias/w-icon");
const w_icon_button_1 = require("../../buttons/w-icon-button");
const w_grid_1 = require("../w-grid");
const w_typography_1 = require("../../others/w-typography");
const w_tooltip_1 = require("../../others/w-tooltip");
class WCarouselInner extends React.Component {
    constructor(props) {
        super(props);
        this.keyHandler = (event) => {
            const active = this.props.active === undefined ? this.state.active : this.props.active;
            if (event.keyCode === 13 && event.altKey) {
                // Alt + Enter
                this.setState({ fullScreen: true });
            }
            else if (event.keyCode === 27) {
                // ESC
                this.setState({ fullScreen: false });
            }
            else if (event.keyCode === 37 && active > 0) {
                // Left
                this.changeActive(active - 1);
            }
            else if (event.keyCode === 39 && active < (this.props.children.length - 1)) {
                // Right
                this.changeActive(active + 1);
            }
        };
        this.changeActive = (active) => {
            this.setState((prevState) => ({ active }), () => {
                this.props.onActiveChanged && this.props.onActiveChanged(active);
            });
        };
        this.state = {
            active: this.props.active || 0,
            fullScreen: false,
        };
    }
    componentDidMount() {
        document.addEventListener("keydown", this.keyHandler, false);
    }
    componentWillUnmount() {
        document.removeEventListener("keydown", this.keyHandler, false);
    }
    renderSlide() {
        const active = this.props.active === undefined ? this.state.active : this.props.active;
        const count = this.props.children.length;
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ style: { maxWidth: '100%', display: 'flex', flex: 1, flexDirection: 'column', height: '100%', background: 'radial-gradient(circle , #fff, #c3bdca)', } }, { children: [(0, jsx_runtime_1.jsxs)(w_grid_1.WGrid, Object.assign({ container: true, style: { opacity: 0.7 } }, { children: [(0, jsx_runtime_1.jsx)(w_grid_1.WGrid, Object.assign({ item: true, xs: 10, style: { padding: 10 } }, { children: (0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: this.props.id + "-btn-fullscreen", color: "primary", onClick: () => this.setState((prevState) => { return { fullScreen: !prevState.fullScreen }; }) }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: "fullscreen" }) })) })), (0, jsx_runtime_1.jsxs)(w_grid_1.WGrid, Object.assign({ item: true, xs: 2, style: { display: 'flex', justifyContent: 'flex-end' } }, { children: [(0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: this.props.id + "-btn-first-page", color: "primary", onClick: () => this.changeActive(0), disabled: active === 0 }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: "first_page" }) })), (0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: this.props.id + "-btn-previous-page", color: "primary", onClick: () => this.changeActive(active - 1), disabled: active === 0 }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: "chevron_left" }) })), (0, jsx_runtime_1.jsx)(w_tooltip_1.WTooltip, Object.assign({ title: this.props.slideTitles[active] }, { children: (0, jsx_runtime_1.jsx)("span", Object.assign({ style: { display: 'flex' } }, { children: (0, jsx_runtime_1.jsxs)(w_typography_1.WTypography, Object.assign({ color: "primary", variant: "button", style: { minWidth: 50, textAlign: 'center', margin: 'auto' } }, { children: [(active + 1), " / ", count] })) })) })), (0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: this.props.id + "-btn-next-page", color: "primary", onClick: () => this.changeActive(active + 1), disabled: active === count - 1 }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: "chevron_right" }) })), (0, jsx_runtime_1.jsx)(w_icon_button_1.WIconButton, Object.assign({ id: this.props.id + "-btn-last-page", color: "primary", onClick: () => this.changeActive(count - 1), disabled: active === count - 1 }, { children: (0, jsx_runtime_1.jsx)(w_icon_1.WIcon, { children: "last_page" }) }))] }))] })), (0, jsx_runtime_1.jsx)(react_swipeable_views_1.default, Object.assign({ index: active, style: { height: '100%', }, containerStyle: { height: '100%' }, slideStyle: { overflow: 'hidden', font: 'roboto' }, onChangeIndex: (active) => this.changeActive(active) }, { children: this.props.children }))] }), "slide"));
    }
    render() {
        let style = { height: '100%' };
        if (this.state.fullScreen) {
            style = { position: 'absolute', top: 0, left: 0, width: '100%', height: '100%', zIndex: 9999 };
        }
        return ((0, jsx_runtime_1.jsx)("div", Object.assign({ style: style }, { children: this.renderSlide() })));
    }
}
exports.WCarousel = (0, withTheme_1.default)(WCarouselInner);
