import { SxProps } from "@mui/material";
import { WithStyles } from "@mui/styles";
import * as React from "react";
import { BaseScreenProps } from "../../..";
import { WTheme } from "../../others/w-theme-provider/w-theme";
import { BaseComponentProps } from "../../base/base-component-props";
import { ReactNode } from 'react';
export interface WNestedPageComponentProps {
    payload: any;
    lastState: any;
    navigateTo: (name: string, payload?: any) => void;
    goBack: () => void;
}
export interface WNestedPageItem extends BaseComponentProps {
    component: React.ElementType<WNestedPageComponentProps & BaseScreenProps>;
    name: string;
    title?: string | ((payload: any) => string);
    icon?: ReactNode;
    subItems?: WNestedPageItem[];
}
export interface WNestedPageLayoutProps extends WithStyles<typeof styles> {
    root: WNestedPageItem;
    state?: WNestedPageLayoutState;
    onStateChanged?: (state: WNestedPageLayoutState) => void;
    design?: {
        navigationButton?: SxProps;
        navigationPopper?: SxProps;
    };
}
export interface WNestedPageLayoutState {
    stack: {
        item?: WNestedPageItem;
        payload: any;
        ref?: React.RefObject<any>;
        state?: any;
    }[];
    anchorEl: any;
    openMenuIndex: number;
}
export declare class WNestedPageLayoutInner extends React.Component<WNestedPageLayoutProps, WNestedPageLayoutState> {
    constructor(props: WNestedPageLayoutProps);
    getTitle: (stackItem: any) => any;
    onStateChanged: () => void;
    renderComponent: (baseScreenProps: BaseScreenProps) => JSX.Element;
    render(): JSX.Element;
}
declare const styles: (theme: WTheme) => import("@mui/styles").StyleRules<{}, "button" | "root" | "iconButton" | "popper">;
export declare const WNestedPageLayout: React.JSXElementConstructor<Omit<WNestedPageLayoutProps, "classes" | "theme"> & import("@mui/styles").StyledComponentProps<"button" | "root" | "iconButton" | "popper">>;
export {};
