"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const styles_1 = require("@mui/material/styles");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const __1 = require("../../../");
// @ts-ignore
const classnames_1 = __importDefault(require("classnames"));
const horizontal_1 = require("horizontal");
const react_router_1 = require("react-router");
const nav_list_1 = __importDefault(require("./nav-list"));
const react_1 = require("react");
const store_1 = require("../../../store");
const material_1 = require("@mui/material");
const toolbar_1 = __importDefault(require("./toolbar"));
const screenData = horizontal_1.Horizontal.getData();
const drawerWidth = screenData.widthType === horizontal_1.WindowWidthType.XS ? screenData.width : 240;
const useStyles = (0, makeStyles_1.default)((theme) => ({
    root: {
        height: "100vh",
        zIndex: theme.zIndex.drawer + 1 + " !important",
        overflow: "hidden",
    },
    flex: {
        flex: 1,
        display: "inline",
    },
    appBar: {
        zIndex: theme.zIndex.drawer + 1 + " !important",
    },
    drawerPaper: {
        width: drawerWidth,
        height: "100%",
    },
    tabLabelContainer: {
        padding: "0px !important",
        paddingLeft: "5px !important",
        textTransform: "none !important",
        wordBreak: "break-word",
        color: "white !important",
    },
    content: {
        flexGrow: 1,
        backgroundColor: theme.palette.background.default,
        padding: 0,
        minWidth: 0,
        display: "flex",
        flexDirection: "column",
        transition: "all ease 250ms",
        height: "inherit",
    },
    "content-left": {
        marginLeft: 0,
    },
    "content-right": {
        marginRight: 0,
    },
    contentShift: {
        transition: theme.transitions.create("margin", {
            easing: theme.transitions.easing.easeOut,
            duration: theme.transitions.duration.enteringScreen,
        }),
    },
    "contentShift-left": {
        marginLeft: drawerWidth,
    },
    "contentShift-right": {
        marginRight: 0,
    },
    whiteText: {
        color: "#FFFFFFFF",
    },
    toolbar: {
        // ...theme.mixins.toolbar,
        height: 48,
        maxHeight: 48,
        "@media only screen and (max-width: 400px)": {
            paddingLeft: 0,
        },
    },
}));
const WMainPage = () => {
    var _a, _b, _c, _d, _e, _f;
    const classes = useStyles();
    const theme = (0, styles_1.useTheme)();
    const appContext = (0, __1.useAppContext)();
    const configuration = (0, store_1.useConfiguration)();
    const [isMenuTreeLoading, setIsMenuTreeLoading] = (0, react_1.useState)(true);
    const authService = configuration.useAuthService();
    const navigate = (0, react_router_1.useNavigate)();
    const { pathname } = (0, react_router_1.useLocation)();
    const [drawerOpen, setDrawerOpen] = (0, react_1.useState)(horizontal_1.Horizontal.getType() == horizontal_1.WindowWidthType.LG);
    const topHeight = 48;
    const getScreenUrl = (0, react_1.useCallback)((screen) => "/" + screen.screen, []);
    const routes = (0, react_1.useMemo)(() => {
        const result = [];
        __1.MenuTreeUtil.menuTreeForEach(appContext.menuTree, (item) => {
            if (item.screen) {
                result.push(item);
            }
            return false;
        });
        return result;
    }, [appContext.menuTree]);
    const onMenuItemClicked = (0, react_1.useCallback)((screen) => {
        if (horizontal_1.Horizontal.getType() !== horizontal_1.WindowWidthType.LG) {
            setDrawerOpen(false);
        }
        appContext.openScreen(screen);
    }, [appContext.openScreen]);
    const loadMenuTree = (0, react_1.useCallback)(() => __awaiter(void 0, void 0, void 0, function* () {
        setIsMenuTreeLoading(true);
        try {
            const menuTree = yield authService.getMenuTree();
            appContext.setMenuTree(menuTree);
            const defaultScreen = __1.MenuTreeUtil.findDefaultScreen(menuTree);
            if (defaultScreen && window.location.pathname === '/main') {
                navigate('/main/' + defaultScreen.id);
            }
        }
        catch (e) {
            console.log("hata", e);
        }
        setIsMenuTreeLoading(false);
    }), [appContext.setMenuTree, authService.getMenuTree]);
    (0, react_1.useEffect)(() => {
        loadMenuTree();
    }, [loadMenuTree]);
    return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: classes.root + " main-page" }, { children: [(0, jsx_runtime_1.jsx)(__1.WAppBar, Object.assign({ id: "main-app-bar", position: "fixed", className: classes.appBar, elevation: (_a = theme.designDetails) === null || _a === void 0 ? void 0 : _a.defaultElevation }, { children: (0, jsx_runtime_1.jsx)(toolbar_1.default, { drawerOpen: drawerOpen, setDrawerOpen: setDrawerOpen }) })), (0, jsx_runtime_1.jsxs)(__1.WDrawer, Object.assign({ variant: "persistent", open: drawerOpen, anchor: "left", classes: {
                    paper: classes.drawerPaper,
                }, PaperProps: {
                    // @ts-ignore
                    style: Object.assign({ 
                        // @ts-ignore
                        border: "none" }, (_c = (_b = theme.designDetails) === null || _b === void 0 ? void 0 : _b.drawerDesign) === null || _c === void 0 ? void 0 : _c.paper),
                    elevation: ((_d = theme.designDetails) === null || _d === void 0 ? void 0 : _d.defaultElevation) || 0,
                } }, { children: [(0, jsx_runtime_1.jsx)("div", { style: { minHeight: topHeight } }), (0, jsx_runtime_1.jsxs)("div", Object.assign({ style: { height: `calc(100% - ${topHeight}px)`, overflow: "none" } }, { children: [(0, jsx_runtime_1.jsx)(__1.WScrollBar, { children: (0, jsx_runtime_1.jsx)(nav_list_1.default, { onItemClicked: onMenuItemClicked }) }), (0, jsx_runtime_1.jsx)("div", Object.assign({ style: {
                                    display: "table",
                                    position: "absolute",
                                    bottom: 0,
                                    height: 25,
                                    width: "100%",
                                } }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ style: {
                                        display: "table-cell",
                                        verticalAlign: "middle",
                                        textAlign: "center",
                                    } }, { children: (0, jsx_runtime_1.jsxs)("span", Object.assign({ style: { color: "#9c9999", fontSize: 10 } }, { children: ["Developed based on", " ", (0, jsx_runtime_1.jsx)("a", Object.assign({ style: {
                                                    fontWeight: 600,
                                                    textDecoration: "none",
                                                    color: "#888",
                                                }, href: "http://wface.digiturk.io", target: "_blank" }, { children: "WFace" }))] })) })) }))] }))] })), (0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ className: (0, classnames_1.default)(classes.content, classes[`content-left`], {
                    [classes.contentShift]: drawerOpen,
                    [classes[`contentShift-left`]]: drawerOpen,
                }), component: "main", sx: (_e = theme.designDetails) === null || _e === void 0 ? void 0 : _e.mainSx }, { children: [(0, jsx_runtime_1.jsx)("div", { style: { minHeight: topHeight } }), (0, jsx_runtime_1.jsx)(__1.WScrollBar, { children: (0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ style: {
                                minHeight: `calc(100vh - ${topHeight}px - 16px)`,
                            }, sx: (_f = theme.designDetails) === null || _f === void 0 ? void 0 : _f.pageSx }, { children: (0, jsx_runtime_1.jsxs)(react_router_1.Routes, { children: [routes.map((item) => ((0, jsx_runtime_1.jsx)(react_router_1.Route, { path: item.id, 
                                        // @ts-ignore
                                        element: 
                                        // @ts-ignore
                                        (0, jsx_runtime_1.jsx)(configuration.components.ScreenWrapper, { menuTreeItem: item }, "screen-" + item.id) }, item.id))), (0, jsx_runtime_1.jsx)(react_router_1.Route, { path: "/", element: null }), (0, jsx_runtime_1.jsx)(react_router_1.Route, { path: "*", element: isMenuTreeLoading ? null : (0, jsx_runtime_1.jsx)(configuration.components.NoPage, {}) })] }) })) })] }))] })));
};
exports.default = WMainPage;
