"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyProfileMenu = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const material_1 = require("@mui/material");
const react_1 = require("react");
const __1 = require("../../../");
const store_1 = require("../../../store");
const MyProfileMenu = ({ items }) => {
    var _a;
    const appContext = (0, store_1.useAppContext)();
    const userContext = (0, store_1.useUserContext)();
    const [userMenuAnchor, setUserMenuAnchor] = (0, react_1.useState)(null);
    const configuration = (0, store_1.useConfiguration)();
    const logoutClicked = (0, react_1.useCallback)(() => {
        var _a, _b;
        userContext.logout();
        try {
            if ((_a = configuration.hooks) === null || _a === void 0 ? void 0 : _a.onLogout) {
                (_b = configuration.hooks) === null || _b === void 0 ? void 0 : _b.onLogout();
            }
        }
        catch (e) {
            console.log(e);
        }
        appContext.clear();
    }, [userContext.logout, appContext.clear]);
    return ((0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ display: "flex", alignItems: "center" }, { children: [((_a = configuration.components) === null || _a === void 0 ? void 0 : _a.TopbarRightItems) && (0, jsx_runtime_1.jsx)(configuration.components.TopbarRightItems, {}), (0, jsx_runtime_1.jsx)(__1.WIconButton, Object.assign({ id: "btn-main-more", "aria-owns": Boolean(userMenuAnchor) ? 'menu-appbar' : '', "aria-haspopup": "true", onClick: (event) => setUserMenuAnchor(event.currentTarget), color: "inherit" }, { children: (0, jsx_runtime_1.jsx)(__1.WIcon, { children: "more_vert" }) })), (0, jsx_runtime_1.jsxs)(__1.WMenu, Object.assign({ id: "menu-appbar", anchorEl: userMenuAnchor, anchorOrigin: {
                    vertical: 'top',
                    horizontal: 'right',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'right',
                }, open: Boolean(userMenuAnchor), onClose: () => setUserMenuAnchor(undefined) }, { children: [items &&
                        items.map((item) => ((0, jsx_runtime_1.jsxs)(__1.WMenuItem, Object.assign({ id: item.id, onClick: (e) => {
                                if (typeof item.onClick === 'function') {
                                    item.onClick(e);
                                    setUserMenuAnchor(undefined);
                                }
                                else {
                                    const screenItem = __1.MenuTreeUtil.findByName(appContext.menuTree, item.onClick || '');
                                    if (!screenItem) {
                                        return;
                                    }
                                    appContext.openScreen(screenItem);
                                    setUserMenuAnchor(undefined);
                                }
                            } }, { children: [item.icon && ((0, jsx_runtime_1.jsx)(__1.WListItemIcon, Object.assign({ style: { minWidth: "auto" } }, { children: typeof item.icon == "string" ? ((0, jsx_runtime_1.jsx)(__1.WIcon, { children: item.icon })) : ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: item.icon })) }))), (0, jsx_runtime_1.jsx)(__1.WListItemText, { style: { marginLeft: 12 }, primary: item.text })] }), item.id))), configuration.authRequired && ((0, jsx_runtime_1.jsxs)(__1.WMenuItem, Object.assign({ id: "menu-item-logout", onClick: logoutClicked }, { children: [(0, jsx_runtime_1.jsx)(__1.WListItemIcon, Object.assign({ style: { minWidth: "auto" } }, { children: (0, jsx_runtime_1.jsx)(__1.WIcon, { children: "exit_to_app" }) })), (0, jsx_runtime_1.jsx)(__1.WListItemText, { style: { marginLeft: 12 }, primary: "Logout" })] }), "menu-item-logout"))] }))] })));
};
exports.MyProfileMenu = MyProfileMenu;
