"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const Collapse_1 = __importDefault(require("@mui/material/Collapse"));
const __1 = require("../../../");
const store_1 = require("../../../store");
const material_1 = require("@mui/material");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const react_router_1 = require("react-router");
const react_router_dom_1 = require("react-router-dom");
const useStyles = (0, makeStyles_1.default)((theme) => ({
    listItemIconRoot: {
        marginRight: 6,
        minWidth: '24px !important'
    },
    listItemRoot: {
        borderRadius: '4px 0px 0px 4px',
        borderBottomColor: theme.palette.background.paper + ' !important',
        '&:hover': {
            backgroundColor: theme.palette.background.default + ' !important'
        }
    }
}));
const NavList = ({ onItemClicked }) => {
    const classes = useStyles();
    const appContext = (0, store_1.useAppContext)();
    const [expandedItems, setExpandedItems] = (0, react_1.useState)({});
    const theme = (0, material_1.useTheme)();
    const { pathname } = (0, react_router_1.useLocation)();
    const hasAnyIcon = (0, react_1.useMemo)(() => {
        let result = false;
        __1.MenuTreeUtil.menuTreeForEach(appContext.menuTree, item => {
            if (item.icon) {
                result = true;
                return true;
            }
            return false;
        });
        return result;
    }, [appContext.menuTree]);
    const currentItem = (0, react_1.useMemo)(() => {
        let result = undefined;
        __1.MenuTreeUtil.menuTreeForEach(appContext.menuTree, item => {
            if (pathname === '/main/' + item.id) {
                result = item;
                return true;
            }
            return false;
        });
        return result;
    }, [appContext.menuTree, pathname]);
    const handleNodeClick = (0, react_1.useCallback)((id) => {
        setExpandedItems(prevExpandedItems => (Object.assign(Object.assign({}, prevExpandedItems), { [id]: prevExpandedItems[id] = !prevExpandedItems[id] })));
    }, []);
    const renderNavItem = (0, react_1.useCallback)((item, hasAnyIcon, nestingLevel = 0) => {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v;
        if (item.hideOnNavigationList) {
            return null;
        }
        const itemStyle = {
            paddingLeft: 10 + 20 * nestingLevel,
        };
        const open = expandedItems[item.id];
        let listItemTextStyle = Object.assign({}, (_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _a === void 0 ? void 0 : _a.drawerDesign) === null || _b === void 0 ? void 0 : _b.menuItem) === null || _c === void 0 ? void 0 : _c.style);
        let listItemStyle = Object.assign({ cursor: 'pointer' }, itemStyle);
        if ((currentItem === null || currentItem === void 0 ? void 0 : currentItem.id) === item.id) {
            listItemTextStyle = {
                color: ((_g = (_f = (_e = (_d = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _d === void 0 ? void 0 : _d.drawerDesign) === null || _e === void 0 ? void 0 : _e.menuItem) === null || _f === void 0 ? void 0 : _f.activeStyle) === null || _g === void 0 ? void 0 : _g.color) || (theme === null || theme === void 0 ? void 0 : theme.palette.primary.main),
                fontWeight: ((_l = (_k = (_j = (_h = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _h === void 0 ? void 0 : _h.drawerDesign) === null || _j === void 0 ? void 0 : _j.menuItem) === null || _k === void 0 ? void 0 : _k.activeStyle) === null || _l === void 0 ? void 0 : _l.fontWeight) || 500,
            };
            listItemStyle = Object.assign(Object.assign({ backgroundColor: theme === null || theme === void 0 ? void 0 : theme.palette.background.default }, listItemStyle), (_p = (_o = (_m = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _m === void 0 ? void 0 : _m.drawerDesign) === null || _o === void 0 ? void 0 : _o.menuItem) === null || _p === void 0 ? void 0 : _p.activeStyle);
        }
        return ((0, jsx_runtime_1.jsxs)("div", { children: [(0, jsx_runtime_1.jsxs)(__1.WListItemButton, Object.assign({ id: "menu-item-" + item.id, classes: { root: classes.listItemRoot }, style: listItemStyle, sx: (_s = (_r = (_q = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _q === void 0 ? void 0 : _q.drawerDesign) === null || _r === void 0 ? void 0 : _r.menuItem) === null || _s === void 0 ? void 0 : _s.sx, onClick: () => {
                        if (!item.screen) {
                            handleNodeClick(item.id);
                        }
                    }, 
                    // @ts-ignore
                    component: item.screen ? react_router_dom_1.Link : undefined, to: item.screen ? item.id : undefined }, { children: [hasAnyIcon &&
                            (0, jsx_runtime_1.jsx)(__1.WListItemIcon, Object.assign({ className: classes.listItemIconRoot }, { children: typeof item.icon == "string" ? ((0, jsx_runtime_1.jsx)(__1.WIcon, { children: item.icon })) : ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: item.icon })) })), (0, jsx_runtime_1.jsx)(__1.WListItemText, { primary: ((0, jsx_runtime_1.jsxs)(material_1.Box, Object.assign({ style: listItemTextStyle, display: "flex", alignItems: "center", justifyContent: "space-between" }, { children: [(0, jsx_runtime_1.jsx)("span", { children: item.text }), item.screen && item.subNodes && item.subNodes.length > 0 && (0, jsx_runtime_1.jsx)(material_1.Box, Object.assign({ sx: { color: theme => theme.palette.text.disabled } }, { children: "|" }))] }))) }), item.subNodes && item.subNodes.length > 0 && (item.screen
                            ? ((0, jsx_runtime_1.jsx)(__1.WIconButton, Object.assign({ size: "small", sx: Object.assign({ p: 0 }, (_v = (_u = (_t = theme === null || theme === void 0 ? void 0 : theme.designDetails) === null || _t === void 0 ? void 0 : _t.drawerDesign) === null || _u === void 0 ? void 0 : _u.menuItem) === null || _v === void 0 ? void 0 : _v.sx), onClick: (e) => {
                                    // e.stopPropagation();
                                    e.preventDefault();
                                    handleNodeClick(item.id);
                                } }, { children: (0, jsx_runtime_1.jsx)(__1.WIcon, { children: open ? "expand_less" : "expand_more" }) })))
                            : ((0, jsx_runtime_1.jsx)(__1.WIcon, Object.assign({ sx: { color: theme => theme.palette.text.secondary } }, { children: open ? "expand_less" : "expand_more" }))))] })), item.subNodes && item.subNodes.length > 0 && ((0, jsx_runtime_1.jsx)(Collapse_1.default, Object.assign({ in: open, timeout: "auto" }, { children: (0, jsx_runtime_1.jsx)(__1.WList, Object.assign({ id: "sub-menu-" + item.id, disablePadding: true }, { children: item.subNodes.map(subItem => { return renderNavItem(subItem, hasAnyIcon, nestingLevel + 1); }) })) })))] }, item.id));
    }, [expandedItems, handleNodeClick, handleNodeClick, currentItem]);
    if (appContext.menuTree && appContext.menuTree.length > 0) {
        return ((0, jsx_runtime_1.jsx)("div", Object.assign({ style: { paddingLeft: 5 } }, { children: (0, jsx_runtime_1.jsx)(__1.WList, Object.assign({ id: "list-menu-tree" }, { children: appContext.menuTree.map((item) => renderNavItem(item, hasAnyIcon)) }), "NavListKey") })));
    }
    else {
        const centerStyle = {
            textAlign: 'center',
            paddingLeft: 20,
            paddingRight: 20,
            paddingTop: 50
        };
        return (0, jsx_runtime_1.jsxs)("div", Object.assign({ style: centerStyle }, { children: [(0, jsx_runtime_1.jsx)(__1.WCircularProgress, { size: 50 }), " "] }));
    }
};
exports.default = NavList;
