"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const components_1 = require("../../../components");
const horizontal_1 = require("horizontal");
const makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
const store_1 = require("../../../store");
const search_1 = require("./search");
const my_profile_menu_1 = require("./my-profile-menu");
const right_drawer_1 = __importDefault(require("./right-drawer"));
const screenData = horizontal_1.Horizontal.getData();
const drawerWidth = screenData.widthType === horizontal_1.WindowWidthType.XS ? screenData.width : 240;
const useStyles = (0, makeStyles_1.default)((theme) => ({
    root: {
        height: "100vh",
        zIndex: theme.zIndex.drawer + 1 + " !important",
        overflow: "hidden",
    },
    flex: {
        flex: 1,
        display: "inline",
    },
    appBar: {
        zIndex: theme.zIndex.drawer + 1 + " !important",
    },
    drawerPaper: {
        width: drawerWidth,
        height: "100%",
    },
    tabLabelContainer: {
        padding: "0px !important",
        paddingLeft: "5px !important",
        textTransform: "none !important",
        wordBreak: "break-word",
        color: "white !important",
    },
    content: {
        flexGrow: 1,
        backgroundColor: theme.palette.background.default,
        padding: 0,
        minWidth: 0,
        display: "flex",
        flexDirection: "column",
        transition: "all ease 250ms",
        height: "inherit",
    },
    "content-left": {
        marginLeft: 0,
    },
    "content-right": {
        marginRight: 0,
    },
    contentShift: {
        transition: theme.transitions.create("margin", {
            easing: theme.transitions.easing.easeOut,
            duration: theme.transitions.duration.enteringScreen,
        }),
    },
    "contentShift-left": {
        marginLeft: drawerWidth,
    },
    "contentShift-right": {
        marginRight: 0,
    },
    whiteText: {
        color: "#FFFFFFFF",
    },
    toolbar: {
        // ...theme.mixins.toolbar,
        height: 48,
        maxHeight: 48,
        "@media only screen and (max-width: 400px)": {
            paddingLeft: 0,
        },
    },
}));
function ToolBar(props) {
    var _a;
    const classes = useStyles();
    const configuration = (0, store_1.useConfiguration)();
    const rightContextItems = configuration.useRightContextItems
        ? configuration.useRightContextItems()
        : [];
    const handleDrawerChange = (0, react_1.useCallback)(() => props.setDrawerOpen(!props.drawerOpen), [props.drawerOpen]);
    return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(components_1.WToolBar, Object.assign({ id: "main-tool-bar", variant: "dense", className: classes.toolbar }, { children: ((_a = configuration.components) === null || _a === void 0 ? void 0 : _a.Toolbar) ? ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: (0, jsx_runtime_1.jsx)(configuration.components.Toolbar, { menuOpen: props.drawerOpen, onMenuToggle: handleDrawerChange }) })) : ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)(components_1.WIconButton, Object.assign({ id: "main-hamburger-button", color: "inherit", "aria-label": "open drawer", style: {
                            transition: "all ease 250ms",
                            transform: props.drawerOpen ? "rotate(180deg)" : "none",
                        }, onClick: handleDrawerChange }, { children: (0, jsx_runtime_1.jsx)(components_1.WIcon, { children: props.drawerOpen && horizontal_1.Horizontal.getType() !== horizontal_1.WindowWidthType.LG
                                ? "close"
                                : "menu" }) })), (0, jsx_runtime_1.jsx)("span", { children: (0, jsx_runtime_1.jsx)(components_1.WTypography, Object.assign({ variant: "h6", color: "inherit", noWrap: true, className: classes.flex }, { children: configuration.projectName })) }), (0, jsx_runtime_1.jsx)("div", { style: { flexGrow: 1 } }), configuration.search && (0, jsx_runtime_1.jsx)(search_1.Search, {}), (0, jsx_runtime_1.jsx)(my_profile_menu_1.MyProfileMenu, { items: rightContextItems }), configuration.rightDrawer && ((0, jsx_runtime_1.jsx)(right_drawer_1.default, { options: configuration.rightDrawer }))] })) })) }));
}
exports.default = ToolBar;
