"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const __1 = require("../../../");
const react_1 = require("react");
const store_1 = require("../../../store");
const material_1 = require("@mui/material");
const notistack_1 = require("notistack");
const WScreenWrapper = ({ menuTreeItem }) => {
    var _a;
    const [pageError, setPageError] = (0, react_1.useState)(null);
    const theme = (0, material_1.useTheme)();
    const screenRef = (0, react_1.useRef)();
    const appContext = (0, store_1.useAppContext)();
    const { enqueueSnackbar } = (0, notistack_1.useSnackbar)();
    const configuration = (0, __1.useConfiguration)();
    const { t } = configuration.useTranslation();
    try {
        const changeScreenMode = (0, react_1.useCallback)((mode = 'normal') => {
            appContext.changeScreenMode(mode);
        }, [appContext.changeScreenMode]);
        const openScreen = (0, react_1.useCallback)((screen, initialValues) => {
            const item = __1.MenuTreeUtil.findByName(appContext.menuTree, screen);
            if (!item) {
                return false;
            }
            appContext.openScreen(item, initialValues);
            return true;
        }, [appContext.menuTree, appContext.openScreen]);
        const showSnackbar = (0, react_1.useCallback)((message, type = 'info', duration = 5000) => {
            enqueueSnackbar(message, {
                variant: type,
                autoHideDuration: duration,
                action: (0, jsx_runtime_1.jsx)(__1.WIconButton, Object.assign({ id: "btn-close-snackbar" }, { children: (0, jsx_runtime_1.jsx)(__1.WIcon, Object.assign({ style: { color: '#ffffff99' }, iconSize: "small" }, { children: "close" })) }))
            });
        }, []);
        const getBaseScreenProps = () => ({
            changeScreenMode,
            openScreen,
            showSnackbar: showSnackbar,
        });
        if (pageError) {
            // @ts-ignore
            return (0, jsx_runtime_1.jsx)(configuration.components.ErrorPage, Object.assign({}, pageError, { t: t }));
        }
        const Screen = configuration.screenList[(menuTreeItem === null || menuTreeItem === void 0 ? void 0 : menuTreeItem.screen) || ''];
        if (!Screen) {
            // @ts-ignore
            return (0, jsx_runtime_1.jsx)(configuration.components.NoPage, {});
        }
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ style: { position: 'relative', width: '100%', height: '100%', } }, { children: [appContext.screenMode === 'loading' &&
                    (0, jsx_runtime_1.jsx)("div", Object.assign({ style: { display: 'table', position: 'absolute', width: '100%', height: 'calc(100% + 8px)', background: '#3f51b544', zIndex: (((_a = theme === null || theme === void 0 ? void 0 : theme.zIndex) === null || _a === void 0 ? void 0 : _a.modal) || 0) + 1 } }, { children: (0, jsx_runtime_1.jsx)("div", Object.assign({ style: { display: 'table-cell', verticalAlign: 'middle', textAlign: 'center' } }, { children: (0, jsx_runtime_1.jsx)(__1.WCircularProgress, { size: 60 }) })) })), (0, jsx_runtime_1.jsx)(__1.BaseScreenPropsContext.Provider, Object.assign({ value: getBaseScreenProps() }, { children: (0, jsx_runtime_1.jsx)(__1.BaseScreenPropsContext.Consumer, { children: (value) => (0, jsx_runtime_1.jsx)(Screen, Object.assign({ ref: screenRef }, value)) }) }))] })));
    }
    catch (error) {
        setPageError({ error });
        return null;
    }
};
exports.default = WScreenWrapper;
