import React, { FC } from "react";
import { IMenuTreeItem } from '..';
export type ScreenMode = "loading" | "normal";
export interface AppContextData {
    menuTree: IMenuTreeItem[];
    cache: {
        [key: string]: any;
    };
    queryParams: {
        [key: string]: any;
    };
    rightDrawerOpen: boolean;
    screenMode: ScreenMode;
}
export interface AppContext extends AppContextData {
    setValue: (key: string, value: any) => void;
    setMenuTree: (menuTree: IMenuTreeItem[]) => void;
    openScreen: (menuTreeItem: IMenuTreeItem, initialValues?: any) => void;
    openScreenById: (id: string, initialValues?: any) => boolean;
    changeScreenMode: (mode: ScreenMode) => void;
    setQueryParams: (queryParams: {
        [key: string]: any;
    }) => void;
    toggleRightDrawer: (open?: boolean) => void;
    clear: () => void;
}
export declare const AppContextProvider: FC<{
    children: React.ReactNode;
}>;
export declare const useAppContext: () => AppContext;
