"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAppContext = exports.AppContextProvider = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_router_1 = require("react-router");
const __1 = require("..");
const defaultData = {
    menuTree: [],
    cache: {},
    queryParams: {},
    rightDrawerOpen: false,
    screenMode: 'normal'
};
const AppContextReact = (0, react_1.createContext)(defaultData);
const AppContextProvider = ({ children }) => {
    const [data, setData] = (0, react_1.useState)((defaultData));
    const navigate = (0, react_router_1.useNavigate)();
    const changeScreenMode = (0, react_1.useCallback)((screenMode) => setData(prev => (Object.assign(Object.assign({}, prev), { screenMode }))), []);
    const clear = (0, react_1.useCallback)(() => setData(defaultData), []);
    const openScreen = (0, react_1.useCallback)((menuTreeItem, initialValues) => {
        navigate('/main/' + menuTreeItem.screen);
    }, []);
    const openScreenById = (0, react_1.useCallback)((id, initialValues) => {
        const menuTreeItem = __1.MenuTreeUtil.find(data.menuTree, id);
        if (menuTreeItem) {
            openScreen(menuTreeItem, initialValues);
            return true;
        }
        return false;
    }, [openScreen, data.menuTree]);
    const setMenuTree = (0, react_1.useCallback)((menuTree) => setData(prev => (Object.assign(Object.assign({}, prev), { menuTree }))), []);
    const setQueryParams = (0, react_1.useCallback)((queryParams) => {
        setData(prev => (Object.assign(Object.assign({}, prev), { queryParams })));
    }, []);
    const setValue = (0, react_1.useCallback)((key, value) => {
        setData(prev => (Object.assign(Object.assign({}, prev), { cache: Object.assign(Object.assign({}, prev.cache), { [key]: value }) })));
    }, []);
    const toggleRightDrawer = (0, react_1.useCallback)((open) => {
        setData(prev => {
            let rightDrawerOpen = !prev.rightDrawerOpen;
            if (open !== undefined) {
                rightDrawerOpen = !!open;
            }
            return Object.assign(Object.assign({}, prev), { rightDrawerOpen });
        });
    }, []);
    const value = (0, react_1.useMemo)(() => (Object.assign(Object.assign({}, data), { changeScreenMode,
        clear,
        openScreen,
        openScreenById,
        setMenuTree,
        setQueryParams,
        setValue,
        toggleRightDrawer })), [
        data, changeScreenMode, clear, openScreen,
        openScreenById, setMenuTree, setQueryParams,
        setValue, toggleRightDrawer
    ]);
    return ((0, jsx_runtime_1.jsx)(AppContextReact.Provider, Object.assign({ value: value }, { children: children })));
};
exports.AppContextProvider = AppContextProvider;
const useAppContext = () => (0, react_1.useContext)(AppContextReact);
exports.useAppContext = useAppContext;
