"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useConfiguration = exports.ConfigContextProvider = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const components_1 = __importDefault(require("../container/components"));
const menu_search_provider_1 = __importDefault(require("../container/components/w-main-page/menu-search-provider"));
const user_context_1 = require("./user-context");
const defaultData = {
    authRequired: true,
    projectName: 'WFace',
    components: components_1.default,
};
const getDefaultData = (configuration) => (Object.assign(Object.assign(Object.assign({}, defaultData), configuration), { components: Object.assign(Object.assign({}, defaultData.components), configuration.components), useAuthService: () => {
        const authService = configuration.useAuthService();
        const userContext = (0, user_context_1.useUserContext)();
        const result = (0, react_1.useMemo)(() => (Object.assign(Object.assign({}, authService), { login: (username, password, values) => __awaiter(void 0, void 0, void 0, function* () {
                var _a;
                try {
                    const response = yield authService.login(username, password, values);
                    userContext.login(Object.assign(Object.assign(Object.assign({}, values), { username }), response));
                    if ((_a = configuration.hooks) === null || _a === void 0 ? void 0 : _a.onLogin) {
                        configuration.hooks.onLogin();
                    }
                    return response;
                }
                catch (e) {
                    throw e;
                }
            }) })), [authService, userContext.login]);
        return result;
    }, searchProvider: Object.assign(Object.assign({}, menu_search_provider_1.default), configuration.searchProvider), useTranslation: () => {
        const defaultTranslation = {
            t: (key) => "",
        };
        if (configuration.useTranslation) {
            return Object.assign(Object.assign({}, defaultTranslation), configuration.useTranslation());
        }
        else {
            return defaultTranslation;
        }
    } }));
const ConfigContextReact = (0, react_1.createContext)(defaultData);
const ConfigContextProvider = ({ children, configuration }) => {
    const value = (0, react_1.useMemo)(() => getDefaultData(configuration), []);
    return ((0, jsx_runtime_1.jsx)(ConfigContextReact.Provider, Object.assign({ value: value }, { children: children })));
};
exports.ConfigContextProvider = ConfigContextProvider;
const useConfiguration = () => (0, react_1.useContext)(ConfigContextReact);
exports.useConfiguration = useConfiguration;
